# Copyright © 2022 Gerald B. Cox
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

case $BASH_SOURCE in
	$0	)
		printf "%s\nScript must be invoked via source command\nExiting\n"
		exit;;
esac

case "${name_search^^}" in
	"QUIT"|"EXIT"	)
	printf "${RED}%s${RESTORE}\n" "Exiting.  You entered $name_search."
	exit;;
	"-H"|"--HELP"	)
	source "$SRC/src-yko-help.sh"
	exit;;
	"BKGND"	)
	term_name=$(ps -o comm= -p "$(($(ps -o ppid= -p "$(($(ps -o sid= -p "$$")))")))")
	if [[ ${term_name^^} == "KONSOLE" ]] && [[ $XDG_CURRENT_DESKTOP == "KDE" ]]; then
		:
	else
		printf "${RED}%s${RESTORE}\n" "Detecting ${term_name^^} terminal running in $XDG_CURRENT_DESKTOP"
		printf "${RED}%s${RESTORE}\n" "Exiting.  Background mode valid only with Konsole running under KDE Plasma."
		exit
	fi
	name_search=""
	BKGND="YES";;
esac

return
