# Copyright © 2022 Gerald B. Cox
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

case $BASH_SOURCE in
	$0	)
		printf "%s\nScript must be invoked via source command\nExiting\n"
		exit;;
esac

printf "%s\n" "This is ykocli v$VERSION" \
" " \
"USAGE: ykocli [search_string]" \
"       ykocli bkgnd   - Konsole Background Mode (KDE Plasma Only" \
"       ykocli quit     - Immediately exit script" \
"       ykocli exit     - Immediately exit script" \
"       ykocli -h       - Display HELP" \
"       ykocli --help   - Display HELP" \
" " \
"EXAMPLES" \
"       Possible ways one can call ykocli:" \
" " \
"       ykocli" \
"              All OATH entries on the inserted YubiKey will be displayed." \
"              You will then be prompted to select which TOTP token you" \
"              wish to have copied to your CopyQ clipboard." \
" " \
"       ykocli [search_string]" \
"              ykocli will only display OATH entries that match the" \
"              search_string entered on the command line." \
"              If the search_string finds more than one match," \
"              you will be prompted to select which TOTP token" \
"              you wish to have copied to your CopyQ clipboard." \
"              If the search_string finds only one match," \
"              that match will automatically be copied to your" \
" " \
"       ykocli bkgnd" \
"              Background Mode" \
"              Only for use with Konsole running under KDE Plasma." \
"              Invoke by using Konsole background mode, i.e." \
"              konsole --background-mode -e ykocli bkgnd or with an" \
"              optional konsole profile, i.e." \
"              konsole --background-mode --profile xyz -e ykocli bkgnd" \
"              This command can be entered using krunner, or as part of" \
"              an autostart routine." \
"              The Konsole window will start in the background.  Press" \
"              the default hotkey CRTL+SHIFT+F12 to toggle the window" \
"              between ACTIVE and BACKGROUND." \
"              An example script to automatically start ykocli in background" \
"              mode is available in /usr/share/doc/ykocli/examples/" \
"              You can invoke from your home directory by entering the command" \
"              bash /usr/share/doc/ykocli/examples/ykocli-konsole-bkgnd.sh" \
" "
return
