# Copyright © 2022 Gerald B. Cox
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

valid_index="NO"

mapfile -t < "$ykman_table"

i=0

count=${#MAPFILE[@]}

source "$SRC/src-yko-figlet.sh"

if [ $count -gt 1 ]; then
	printf "\n${GREEN}Please choose an entry below:\n"

	while [[ "$i" -lt "$count" ]]; do

		fullstring=${MAPFILE[$i]}
		namestring=${MAPFILE[$i]% *}
		namestring="${namestring%"${namestring##*[![:space:]]}"}"
		
		if [[ $(( i % 2 )) == 0 ]]
		then
			printf "${YELLOW}index=%-2s ====> ${YELLOW}$namestring\n" $i
		else
			printf "${LBLUE}index=%-2s ====> ${LBLUE}$namestring\n" $i
		fi
		
		let i++
	
	done

	until [[ $valid_index == "YES" ]]; do

	printf "\n${PURPLE}Please enter desired numeric index value and press ${CYAN}\n"
	read -p "[ENTER]:  " input_index

	case "${input_index^^}" in
		"QUIT"|"EXIT"   )
		 printf "${RED}%s${RESTORE}\n" "Exiting.  You entered $input_index."
		 sleep 5
		exit;;
	esac

	if  ! [[ ${input_index} =~ $ck_index ]]; then
		valid_index="NO"
		printf "${LYELLOW}Invalid entry\n"
	elif [[ "$count" -gt "$input_index" ]]; then
		valid_index="YES"
	fi

	done

else
	input_index=0
fi

fullstring=${MAPFILE[$input_index]}
namestring=${MAPFILE[$input_index]% *}
namestring="${namestring%"${namestring##*[![:space:]]}"}"
authcode=$(ykman oath accounts code "$namestring")

authcode=${authcode##* }

if copyq copy $authcode &> /dev/null; then
	copyq_msg="is now in the clipboard"
else
	copyq_msg="must be manually copied to clipboard"
	printf "\n${RED}CopyQ daemon inactive, disabling clipboard functionality\n"
fi

printf "\n${LBLUE}Entry $namestring has been selected\n"
printf "${LGREEN}TOTP token ${LYELLOW}$authcode ${LGREEN}$copyq_msg\n"

source "$SRC/src-yko-time.sh"

if [[ $remaining_seconds -le $REGEN ]]; then

	printf "\n\n${LRED}TOTP token expiration was below configuration threshold\n"

	printf "\r${CLRLINE}${LGREEN}Generating replacement TOTP token $countdown_message"

	authcode=$(ykman oath accounts code "$namestring")
	authcode=${authcode##* }

	copyq copy $authcode &> /dev/null

	printf "\r${LGREEN}Replacement TOTP token ${LYELLOW}$authcode ${LGREEN}$copyq_msg\n"

	source "$SRC/src-yko-time.sh"

fi

printf "${RESTORE}\n"
return
